from shutil import copyfile
import os
import requests

# 抓取文件类型
BuildRelease = True
aarType = "-release.aar" if BuildRelease else "-debug.aar"

pluginFilePath = '../.flutter-plugins'

# 当前项目的flutter.aar
currentFlutterPath = '../.android/Flutter/build/outputs/aar/'

# 输出地址
outputFilePath = os.path.abspath('flutter_aar.py').replace("flutter_aar.py", "aars/")

endPath = 'android/build/outputs/aar/'

def collect_aar(plugins):
    all_collection_success = True
    if os.path.exists(outputFilePath):
        print('copy aar to: ' + outputFilePath)
    else:
        print('target path: ' + outputFilePath + ' not exist')
        os.makedirs(outputFilePath)
        print('create target path: ' + outputFilePath)

    for key, value in plugins.items():
        aar_path = value + key + aarType
        try:
            copyfile(aar_path, outputFilePath + key + aarType)
            print('copy flutter aar success at path: ' + aar_path)
        except IOError:
            all_collection_success = False
            print('copy flutter aar error at path: ' + aar_path)

    if all_collection_success:
        upload_to_repository()
    pass


def upload_to_repository():
    # files = {'flutter_aar.sh': open('/Users/deadline/personal/Python/project/learn/com/deadline/flutter_aar.sh', 'rb')}
    # upload_data = {'enctype': 'multipart/form-data', 'name': 'application/octet-stream'}
    # response = requests.post("http://127.0.0.1:5000", upload_data, files)
    # print(response)
    pass


file_object = open(pluginFilePath, 'r')
try:
    plugin_map = {}
    for line in file_object:
        array = line.split('=')
        plugin_map[array[0]] = array[1].replace('\n', '') + endPath

    plugin_map['flutter'] = currentFlutterPath
    collect_aar(plugin_map)
finally:
    file_object.close()
