#!/usr/bin/env bash
echo "Clean old build"
find . -d -name "build" | xargs rm -rf
flutter clean

echo "Get packages"
flutter packages get

echo "Build release AOT"
flutter build aot --release --preview-dart-2 --output-dir=build/flutteroutput/aot
echo "Build release Bundle"
flutter build bundle --precompiled --preview-dart-2 --asset-dir=build/flutteroutput/flutter_assets

echo 'Clean packflutter input(flutter build)'
rm -f -r android/packflutter/flutter/

# 拷贝flutter.jar
echo 'Copy flutter jar'
mkdir -p android/packflutter/flutter/flutter/android-arm-release && cp flutter/bin/cache/artifacts/engine/android-arm-release/flutter.jar "$_"


# 拷贝asset
echo 'Copy flutter asset'
mkdir -p android/packflutter/flutter/assets/release && cp -r build/flutteroutput/aot/* "$_"
mkdir -p android/packflutter/flutter/assets/release/flutter_assets && cp -r build/flutteroutput/flutter_assets/* "$_"

# 将flutter库和flutter_app打成aar 同时publish到Ali-maven
echo 'Build and publish idlefish flutter to aar'
cd android
if [ -n "$1" ]
then
  ./gradlew :packflutter:clean :packflutter:publish -PAAR_VERSION=$1
else
  ./gradlew :packflutter:clean :packflutter:publish
fi
cd ../


# 将plugin发布到Ali-maven
echo "Start publish flutter-plugins"
for line in $(cat .flutter-plugins)
do
    plugin_name=${line%%=*}
    echo 'Build and publish plugin:' ${plugin_name}

    cd android
    if [ -n "$1" ]
    then
    ./gradlew :${plugin_name}:clean :${plugin_name}:publish -PAAR_VERSION=$1
  else
    ./gradlew :${plugin_name}:clean :${plugin_name}:publish
  fi
  cd ../
done