#!/usr/bin/env ruby
require 'xcodeproj'
require 'fileutils'

puts ">>> 所有插件静态库打包"
Dir.chdir ".ios/Pods"
pod_project_path = "Pods.xcodeproj"
proj = Xcodeproj::Project.open(pod_project_path)
validTargets = proj.targets.select { |item| item.name != "Pods-Runner" }
validTargets.each { |target| 
    puts ">>> lib#{target}.a开始打包..."
    `/usr/bin/env xcrun xcodebuild build -configuration Release ARCHS='arm64 armv7' -target #{target} BUILD_DIR=../../build/ios -sdk iphoneos -quiet`
    `/usr/bin/env xcrun xcodebuild build -configuration Debug ARCHS='x86_64' -target #{target} BUILD_DIR=../../build/ios -sdk iphonesimulator -quiet`
    `lipo -create "../../build/ios/Debug-iphonesimulator/#{target}/lib#{target}.a" "../../build/ios/Release-iphoneos/#{target}/lib#{target}.a" -o "../../product/lib#{target}.a"`
    puts ">>> lib#{target}.a打包完成"
}

puts ">>> 所有插件静态库头文件复制"
Dir.chdir "../../"
File.open(".flutter-plugins", "r") do |file|
    file.each_line do |line|
        array = line.split("=")
        classes = array.last.chomp + "ios/Classes"
        Dir["#{classes}/*.h"].each do |header|
            FileUtils.cp "#{header}", "product/"
        end
    end
end

puts ">>> 插件注册表头文件复制"
Dir[".ios/Flutter/FlutterPluginRegistrant/**/*.h"].each do |header|
    FileUtils.cp "#{header}", "product/"
end

puts ">>> All done."